<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MessageSearch StructType
 * @subpackage Structs
 */
class MessageSearch extends SearchRecord
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchBasic
     */
    public $basic;
    /**
     * The attachmentsJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\FileSearchBasic
     */
    public $attachmentsJoin;
    /**
     * The authorJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EntitySearchBasic
     */
    public $authorJoin;
    /**
     * The campaignJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CampaignSearchBasic
     */
    public $campaignJoin;
    /**
     * The caseJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SupportCaseSearchBasic
     */
    public $caseJoin;
    /**
     * The contactJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ContactSearchBasic
     */
    public $contactJoin;
    /**
     * The customerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerSearchBasic
     */
    public $customerJoin;
    /**
     * The employeeJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchBasic
     */
    public $employeeJoin;
    /**
     * The entityJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EntitySearchBasic
     */
    public $entityJoin;
    /**
     * The opportunityJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OpportunitySearchBasic
     */
    public $opportunityJoin;
    /**
     * The originatingLeadJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OriginatingLeadSearchBasic
     */
    public $originatingLeadJoin;
    /**
     * The partnerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PartnerSearchBasic
     */
    public $partnerJoin;
    /**
     * The recipientJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EntitySearchBasic
     */
    public $recipientJoin;
    /**
     * The transactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchBasic
     */
    public $transactionJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchBasic
     */
    public $userJoin;
    /**
     * The vendorJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\VendorSearchBasic
     */
    public $vendorJoin;
    /**
     * Constructor method for MessageSearch
     * @uses MessageSearch::setBasic()
     * @uses MessageSearch::setAttachmentsJoin()
     * @uses MessageSearch::setAuthorJoin()
     * @uses MessageSearch::setCampaignJoin()
     * @uses MessageSearch::setCaseJoin()
     * @uses MessageSearch::setContactJoin()
     * @uses MessageSearch::setCustomerJoin()
     * @uses MessageSearch::setEmployeeJoin()
     * @uses MessageSearch::setEntityJoin()
     * @uses MessageSearch::setOpportunityJoin()
     * @uses MessageSearch::setOriginatingLeadJoin()
     * @uses MessageSearch::setPartnerJoin()
     * @uses MessageSearch::setRecipientJoin()
     * @uses MessageSearch::setTransactionJoin()
     * @uses MessageSearch::setUserJoin()
     * @uses MessageSearch::setVendorJoin()
     * @param \StructType\MessageSearchBasic $basic
     * @param \StructType\FileSearchBasic $attachmentsJoin
     * @param \StructType\EntitySearchBasic $authorJoin
     * @param \StructType\CampaignSearchBasic $campaignJoin
     * @param \StructType\SupportCaseSearchBasic $caseJoin
     * @param \StructType\ContactSearchBasic $contactJoin
     * @param \StructType\CustomerSearchBasic $customerJoin
     * @param \StructType\EmployeeSearchBasic $employeeJoin
     * @param \StructType\EntitySearchBasic $entityJoin
     * @param \StructType\OpportunitySearchBasic $opportunityJoin
     * @param \StructType\OriginatingLeadSearchBasic $originatingLeadJoin
     * @param \StructType\PartnerSearchBasic $partnerJoin
     * @param \StructType\EntitySearchBasic $recipientJoin
     * @param \StructType\TransactionSearchBasic $transactionJoin
     * @param \StructType\EmployeeSearchBasic $userJoin
     * @param \StructType\VendorSearchBasic $vendorJoin
     */
    public function __construct(\StructType\MessageSearchBasic $basic = null, \StructType\FileSearchBasic $attachmentsJoin = null, \StructType\EntitySearchBasic $authorJoin = null, \StructType\CampaignSearchBasic $campaignJoin = null, \StructType\SupportCaseSearchBasic $caseJoin = null, \StructType\ContactSearchBasic $contactJoin = null, \StructType\CustomerSearchBasic $customerJoin = null, \StructType\EmployeeSearchBasic $employeeJoin = null, \StructType\EntitySearchBasic $entityJoin = null, \StructType\OpportunitySearchBasic $opportunityJoin = null, \StructType\OriginatingLeadSearchBasic $originatingLeadJoin = null, \StructType\PartnerSearchBasic $partnerJoin = null, \StructType\EntitySearchBasic $recipientJoin = null, \StructType\TransactionSearchBasic $transactionJoin = null, \StructType\EmployeeSearchBasic $userJoin = null, \StructType\VendorSearchBasic $vendorJoin = null)
    {
        $this
            ->setBasic($basic)
            ->setAttachmentsJoin($attachmentsJoin)
            ->setAuthorJoin($authorJoin)
            ->setCampaignJoin($campaignJoin)
            ->setCaseJoin($caseJoin)
            ->setContactJoin($contactJoin)
            ->setCustomerJoin($customerJoin)
            ->setEmployeeJoin($employeeJoin)
            ->setEntityJoin($entityJoin)
            ->setOpportunityJoin($opportunityJoin)
            ->setOriginatingLeadJoin($originatingLeadJoin)
            ->setPartnerJoin($partnerJoin)
            ->setRecipientJoin($recipientJoin)
            ->setTransactionJoin($transactionJoin)
            ->setUserJoin($userJoin)
            ->setVendorJoin($vendorJoin);
    }
    /**
     * Get basic value
     * @return \StructType\MessageSearchBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\MessageSearchBasic $basic
     * @return \StructType\MessageSearch
     */
    public function setBasic(\StructType\MessageSearchBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get attachmentsJoin value
     * @return \StructType\FileSearchBasic|null
     */
    public function getAttachmentsJoin()
    {
        return $this->attachmentsJoin;
    }
    /**
     * Set attachmentsJoin value
     * @param \StructType\FileSearchBasic $attachmentsJoin
     * @return \StructType\MessageSearch
     */
    public function setAttachmentsJoin(\StructType\FileSearchBasic $attachmentsJoin = null)
    {
        $this->attachmentsJoin = $attachmentsJoin;
        return $this;
    }
    /**
     * Get authorJoin value
     * @return \StructType\EntitySearchBasic|null
     */
    public function getAuthorJoin()
    {
        return $this->authorJoin;
    }
    /**
     * Set authorJoin value
     * @param \StructType\EntitySearchBasic $authorJoin
     * @return \StructType\MessageSearch
     */
    public function setAuthorJoin(\StructType\EntitySearchBasic $authorJoin = null)
    {
        $this->authorJoin = $authorJoin;
        return $this;
    }
    /**
     * Get campaignJoin value
     * @return \StructType\CampaignSearchBasic|null
     */
    public function getCampaignJoin()
    {
        return $this->campaignJoin;
    }
    /**
     * Set campaignJoin value
     * @param \StructType\CampaignSearchBasic $campaignJoin
     * @return \StructType\MessageSearch
     */
    public function setCampaignJoin(\StructType\CampaignSearchBasic $campaignJoin = null)
    {
        $this->campaignJoin = $campaignJoin;
        return $this;
    }
    /**
     * Get caseJoin value
     * @return \StructType\SupportCaseSearchBasic|null
     */
    public function getCaseJoin()
    {
        return $this->caseJoin;
    }
    /**
     * Set caseJoin value
     * @param \StructType\SupportCaseSearchBasic $caseJoin
     * @return \StructType\MessageSearch
     */
    public function setCaseJoin(\StructType\SupportCaseSearchBasic $caseJoin = null)
    {
        $this->caseJoin = $caseJoin;
        return $this;
    }
    /**
     * Get contactJoin value
     * @return \StructType\ContactSearchBasic|null
     */
    public function getContactJoin()
    {
        return $this->contactJoin;
    }
    /**
     * Set contactJoin value
     * @param \StructType\ContactSearchBasic $contactJoin
     * @return \StructType\MessageSearch
     */
    public function setContactJoin(\StructType\ContactSearchBasic $contactJoin = null)
    {
        $this->contactJoin = $contactJoin;
        return $this;
    }
    /**
     * Get customerJoin value
     * @return \StructType\CustomerSearchBasic|null
     */
    public function getCustomerJoin()
    {
        return $this->customerJoin;
    }
    /**
     * Set customerJoin value
     * @param \StructType\CustomerSearchBasic $customerJoin
     * @return \StructType\MessageSearch
     */
    public function setCustomerJoin(\StructType\CustomerSearchBasic $customerJoin = null)
    {
        $this->customerJoin = $customerJoin;
        return $this;
    }
    /**
     * Get employeeJoin value
     * @return \StructType\EmployeeSearchBasic|null
     */
    public function getEmployeeJoin()
    {
        return $this->employeeJoin;
    }
    /**
     * Set employeeJoin value
     * @param \StructType\EmployeeSearchBasic $employeeJoin
     * @return \StructType\MessageSearch
     */
    public function setEmployeeJoin(\StructType\EmployeeSearchBasic $employeeJoin = null)
    {
        $this->employeeJoin = $employeeJoin;
        return $this;
    }
    /**
     * Get entityJoin value
     * @return \StructType\EntitySearchBasic|null
     */
    public function getEntityJoin()
    {
        return $this->entityJoin;
    }
    /**
     * Set entityJoin value
     * @param \StructType\EntitySearchBasic $entityJoin
     * @return \StructType\MessageSearch
     */
    public function setEntityJoin(\StructType\EntitySearchBasic $entityJoin = null)
    {
        $this->entityJoin = $entityJoin;
        return $this;
    }
    /**
     * Get opportunityJoin value
     * @return \StructType\OpportunitySearchBasic|null
     */
    public function getOpportunityJoin()
    {
        return $this->opportunityJoin;
    }
    /**
     * Set opportunityJoin value
     * @param \StructType\OpportunitySearchBasic $opportunityJoin
     * @return \StructType\MessageSearch
     */
    public function setOpportunityJoin(\StructType\OpportunitySearchBasic $opportunityJoin = null)
    {
        $this->opportunityJoin = $opportunityJoin;
        return $this;
    }
    /**
     * Get originatingLeadJoin value
     * @return \StructType\OriginatingLeadSearchBasic|null
     */
    public function getOriginatingLeadJoin()
    {
        return $this->originatingLeadJoin;
    }
    /**
     * Set originatingLeadJoin value
     * @param \StructType\OriginatingLeadSearchBasic $originatingLeadJoin
     * @return \StructType\MessageSearch
     */
    public function setOriginatingLeadJoin(\StructType\OriginatingLeadSearchBasic $originatingLeadJoin = null)
    {
        $this->originatingLeadJoin = $originatingLeadJoin;
        return $this;
    }
    /**
     * Get partnerJoin value
     * @return \StructType\PartnerSearchBasic|null
     */
    public function getPartnerJoin()
    {
        return $this->partnerJoin;
    }
    /**
     * Set partnerJoin value
     * @param \StructType\PartnerSearchBasic $partnerJoin
     * @return \StructType\MessageSearch
     */
    public function setPartnerJoin(\StructType\PartnerSearchBasic $partnerJoin = null)
    {
        $this->partnerJoin = $partnerJoin;
        return $this;
    }
    /**
     * Get recipientJoin value
     * @return \StructType\EntitySearchBasic|null
     */
    public function getRecipientJoin()
    {
        return $this->recipientJoin;
    }
    /**
     * Set recipientJoin value
     * @param \StructType\EntitySearchBasic $recipientJoin
     * @return \StructType\MessageSearch
     */
    public function setRecipientJoin(\StructType\EntitySearchBasic $recipientJoin = null)
    {
        $this->recipientJoin = $recipientJoin;
        return $this;
    }
    /**
     * Get transactionJoin value
     * @return \StructType\TransactionSearchBasic|null
     */
    public function getTransactionJoin()
    {
        return $this->transactionJoin;
    }
    /**
     * Set transactionJoin value
     * @param \StructType\TransactionSearchBasic $transactionJoin
     * @return \StructType\MessageSearch
     */
    public function setTransactionJoin(\StructType\TransactionSearchBasic $transactionJoin = null)
    {
        $this->transactionJoin = $transactionJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchBasic $userJoin
     * @return \StructType\MessageSearch
     */
    public function setUserJoin(\StructType\EmployeeSearchBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get vendorJoin value
     * @return \StructType\VendorSearchBasic|null
     */
    public function getVendorJoin()
    {
        return $this->vendorJoin;
    }
    /**
     * Set vendorJoin value
     * @param \StructType\VendorSearchBasic $vendorJoin
     * @return \StructType\MessageSearch
     */
    public function setVendorJoin(\StructType\VendorSearchBasic $vendorJoin = null)
    {
        $this->vendorJoin = $vendorJoin;
        return $this;
    }
}
